Redmine - Defect #19017

Wiki PDF Export: <pre> not rendered with monospaced font
2015-02-03 23:44 - Marcel Muller

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Toshi MARUYAMA % Done: 0%
Category: PDF export Estimated time: 0.00 hour
Target version: 3.2.0

Resolution: Affected version: 2.6.1
Description

In redmine < pre > tags are rendered with a monospaced font. When exporting a wiki with a < pre > element, this element is not
rendered with a monospaced font, loosing the intended "formatting".
Associated revisions

Revision 14907 - 2015-12-04 06:42 - Toshi MARUYAMA

pdf: use "family" parameter instead of I(:general_pdf_fontname) at SetFont method (#19017)
Contributed by Jun NAITOH.

Revision 14908 - 2015-12-04 06:42 - Toshi MARUYAMA

pdf: upgrade rbpdf to 1.19.0 (#19017)

Contributed by Jun NAITOH.

Revision 14909 - 2015-12-04 06:43 - Toshi MARUYAMA

pdf: add general_pdf_monospaced_fontname to locales (#19017)
Contributed by Jun NAITOH.

Revision 14910 - 2015-12-04 06:43 - Toshi MARUYAMA

pdf: use I(:general_pdf_monospaced_fontname) (#19017)
Contributed by Jun NAITOH.

Revision 14911 - 2015-12-04 07:50 - Toshi MARUYAMA

revert r14907 (#19017)

r14907 breaks Arabic italic pdf rendering.
Revision 14912 - 2015-12-04 08:29 - Toshi MARUYAMA
Merged r14908, r14909 and r14910 from trunk to 3.2-stable (#19017)

Revision 14950 - 2015-12-06 07:35 - Toshi MARUYAMA

pdf: use "family" parameter instead of I(:general_pdf_fontname) at SetFont method (#19017)
Contributed by Jun NAITOH.

Revision 14951 - 2015-12-06 08:22 - Toshi MARUYAMA

revert r14950 (#19017)

r14907 breaks Arabic italic pdf rendering.

Revision 14959 - 2015-12-06 13:21 - Toshi MARUYAMA

pdf: use "family" parameter instead of I(:general_pdf_fontname) at SetFont method (#19017)
Contributed by Jun NAITOH.

Revision 14960 - 2015-12-06 13:21 - Toshi MARUYAMA

pdf: remove italic from DejaVuSansMono (#19017)

DejaVuSansMono ltalic Arabic font has problem.

Contributed by Jun NAITOH.

Revision 14961 - 2015-12-06 13:24 - Toshi MARUYAMA

Merged r14959 from trunk to 3.2-stable (#19017)

pdf: use "family" parameter instead of I(:general_pdf_fontname) at SetFont method.
Contributed by Jun NAITOH.

Revision 14962 - 2015-12-06 13:24 - Toshi MARUYAMA

Merged r14960 from trunk to 3.2-stable (#19017)

pdf: remove italic from DejaVuSansMono.

DejaVuSansMono ltalic Arabic font has problem.

Contributed by Jun NAITOH.

Revision 14963 - 2015-12-06 13:36 - Toshi MARUYAMA

pdf: use all lower cases for DejaVuSansMono (#19017)

Revision 14964 - 2015-12-06 13:38 - Toshi MARUYAMA
Merged r14963 from trunk to 3.2-stable (#19017)

pdf: use all lower cases for DejaVuSansMono.

History

#1 - 2015-02-05 20:48 - Marcel Miiller

| think the problem is in this line. "set_default_monospaced_font" should not be set to the default content-font (a non monospaced font). Removing
this line works for me.

#2 - 2015-03-03 15:24 - Toshi MARUYAMA
- File fonts.png added

Marcel Muller wrote:

Removing this line works for me.

But, [ Cyrillic is broken.
#3 - 2015-03-03 15:27 - Toshi MARUYAMA

| have created issue.

https://github.com/naitoh/rbpdf/issues/11

#4 - 2015-11-21 06:52 - Jun NAITOH

- File rbpdf-1.19.0_ monospaced_font.pdf added

- File pdf_monospaced _font r14882.patch added

This is font problem.

rbpdf 1.19.0 was added DejaVu SansMono font,
and Supported for font subsetting. (for reduce the size of documents using large unicode font files.)

Please use monospaced font. (see attached patch and sample pdf.)

language font list

config/locales

Proportional font

Monospaced font

notes

ar.yml DejaVuSans DejaVuSansMono DejaVuSansMono ltalic Arabic font
has problem.

az.yml freesans freemono

bg.yml freesans freemono

bs.yml freesans freemono

ca.yml freesans freemono

cs.yml freesans freemono

da.yml freesans freemono

de.yml freesans freemono

el.yml freesans freemono

en-GB.yml freesans freemono

en.yml freesans freemono

es-PA.yml freesans freemono

es.yml freesans freemono

et.yml freesans freemono

eu.yml freesans freemono

fa.yml DejaVuSans DejaVuSans DejaVuSansMono Persian font has
problem.

fi.yml freesans freemono

fr.yml freesans freemono

gl.ymi freesans freemono

he.yml freesans freemono

hr.yml freesans freemono

hu.yml freesans freemono

id.yml freesans freemono

it.ymi freesans freemono

ja.yml kozminproregular kozminproregular

ko.yml hysmyeongjostdmedium hysmyeongjostdmedium

It.yml freesans freemono

Iv.yml freesans freemono

mk.yml freesans freemono

mn.yml freesans freemono

nl.yml freesans freemono

no.yml freesans freemono

pl.yml freesans freemono
pt-BR.yml freesans freemono

pt.yml freesans freemono

ro.yml freesans freemono

ru.yml freesans freemono

sk.yml freesans freemono

sl.yml freesans freemono

sqg.yml freesans freemono

sr-YU.yml freesans freemono

sr.yml freesans freemono

sv.yml freesans freemono

th.yml freeserif freeserif freesans and freemono Thai fonts
have problem.

tr.yml freesans freemono

uk.yml freesans freemono

vi.yml DejaVuSans DejaVuSans DejaVuSansMono Vietnamese font
has problem.

zh-TW.yml msungstdlight msungstdlight

zh.yml stsongstdlight stsongstdlight

#5 - 2015-11-23 05:43 - Go MAEDA

- Target version set to 3.2.0

Thanks for the patch. Works fine for me.

#6 - 2015-11-28 07:29 - Toshi MARUYAMA
- Assignee set to Toshi MARUYAMA

#7 - 2015-12-04 08:21 - Toshi MARUYAMA
- File Arabic.txt added

| have committed from r14907 to r14911 without this change.

=== (+3,-1) lib/redmine/export/pdf.rb ===
@@ -55,6 +55,8 @@

style.delete! ('B') if 1(:general_pdf_fontname) == 'freeserif'

# DejaVuSans Italic Arabic and Persian font has problem.

style.delete! ('I'") if 1l(:general_pdf_ fontname) == 'DejaVuSans' && current_language.to_s.casecmp ("vi
"y I=0
+ # DejaVuSansMono Italic Arabic font has problem.
+ style.delete! ('I') if 1l(:general_pdf_fontname) == 'DejaVuSansMono'

super (family, style, size, fontfile)
end
alias_method :set_font, :SetFont

| cannot see difference with and without this change on Arabic.txt.
Is this change needed?

#8 - 2015-12-04 08:23 - Toshi MARUYAMA
Toshi MARUYAMA wrote:

| cannot see difference with and without this change on Arabic.txt.

On Arabic locale.

#9 - 2015-12-05 07:26 - Jun NAITOH

| cannot see difference with and without this change on Arabic.txt.
Is this change needed?
| checked it once again. so, this change is unnecessary, Sorry.

Because Redmine 3.2(r14911) used a monospaced font in the pre tag, but a style(bold/italic) wasn't applied in the pre tag.

#10 - 2015-12-05 11:55 - Toshi MARUYAMA
- File pdf.png added
- File html.png added

But monospace italic is in HTML source.
Does not PDF support "code" and %f{font-style: italic; font-family: monospace}word%?

${font-style: italic; font-family: monospace}italic monospace$%
_italic_
@monospace@
#11 - 2015-12-05 15:26 - Jun NAITOH
Toshi MARUYAMA wrote:

But monospace italic is in HTML source.
Does not PDF support "code" and %f{font-style: italic; font-family: monospace}word%?

PDF don't support "code" and %{font-family: monospace}word%
but, PDF support %({font-style: italic; font-family: DejaVuSansMono}word%
If use %f{font-style: italic; font-family: DejaVuSansMono}word%, it's no problem by following setting on Arabic locale.

style.delete! ('I'") if 1l(:general pdf_ fontname) == 'DejaVuSans' && current_language.to_s.casecmp ("vi

#12 - 2015-12-06 05:53 - Toshi MARUYAMA

| can see DejaVuSansMono italic has problem in Vietnamese, but | cannot see in Arabic.
Where is source?

#13 - 2015-12-06 07:48 - Toshi MARUYAMA
Toshi MARUYAMA wrote:

| can see DejaVuSansMono italic has problem in Vietnamese, but | cannot see in Arabic.
This behaviour changes frequently. "family" parameter of SetFont() sometimes comes all lower-cases.

source:trunk/lib/redmine/export/pdf.ro@14949#L 53
r14950 stabilizes behaviour changes.

#14 - 2015-12-06 08:31 - Toshi MARUYAMA
Toshi MARUYAMA wrote:

14950 stabilizes behaviour changes.

But r14950 breaks Arabic italic pdf rendering again.
(I mistook r14951 comment.)

#15 - 2015-12-06 08:45 - Toshi MARUYAMA
- File ar-en.png added

| try with this change on r14951, English locale is OK, but Arabic locale is NG.
I think SetFont() has stability bug.

%{font-style: italic; font-family: DejaVuSansMono}Tié&ng Viét$%
${font-style: italic; font-family: DejaVuSansMono}l000%

diff --git a/config/locales/ar.yml b/config/locales/ar.yml

-—- a/config/locales/ar.yml

+++ b/config/locales/ar.yml

@@ -140,8 +140,8 @@
general_csv_separator: ',
general_csv_decimal_separator: '.'
general_csv_encoding: ISO-8859-1

- general_pdf_fontname: DejaVuSans

- general_pdf_monospaced_fontname: DejaVuSansMono

+ general_pdf_fontname: freesans

+ general_pdf_monospaced_fontname: freemono
general_first_day_of_week: '7'

notice_account_updated: 00000 000000 00000 OO0 OOD.

diff --git a/config/locales/en.yml b/config/locales/en.yml

-—— a/config/locales/en.yml

+++ b/config/locales/en.yml

@@ -141,8 +141,8 @@
general_csv_separator: ',
general_csv_decimal_separator: '.'
general_csv_encoding: ISO-8859-1

- general_pdf_fontname: freesans

- general_pdf_monospaced_fontname: freemono

+ general_pdf_fontname: DejaVuSans

+ general_pdf_monospaced_fontname: DejaVuSansMono
general_first_day_of_week: '7'

notice_account_updated: Account was successfully updated.

2025-05-01 7/8


https://www.redmine.org/projects/redmine/repository/svn/revisions/14949/entry/trunk/lib/redmine/export/pdf.rb#L53
https://www.redmine.org/projects/redmine/repository/svn/revisions/14950
https://www.redmine.org/projects/redmine/repository/svn/revisions/14950
https://www.redmine.org/projects/redmine/repository/svn/revisions/14950
https://www.redmine.org/projects/redmine/repository/svn/revisions/14951
https://www.redmine.org/projects/redmine/repository/svn/revisions/14951

Tifjng Viét

Tillng Viét

History

#1 - 12/06/2015 02:48 PM - Akai Kouseki
Tillng Viét

#2 - 12/06/2015 02:54 PM - Akai Kouseki

[N

#16 - 2015-12-06 12:24 - Jean-Philippe Lang

- Status changed from New to Closed

Akai Kouseki-[00[00[

Akai Kouseki-[000000

02:48 12/06/2015 - 1#
Tillng Viét

02:54 12/06/2015 - 2%
ooa

I'm closing this for 3.2 release. If there any problems pending, please open another issue.

#17 - 2015-12-06 13:27 - Toshi MARUYAMA
r14950 is wrong.

style.delete! ('I') if family.to_s.casecmp ('DejavVuSans') != 0

should be

style.delete! ('I'") if family.to_s.casecmp ('DejaVuSans') == 0

#18 - 2015-12-06 13:29 - Toshi MARUYAMA

Jean-Philippe Lang wrote:

I'm closing this for 3.2 release. If there any problems pending, please open another issue.

3.2-stable r14962 has completed.
Please release 3.2.0.

#19 - 2015-12-06 13:39 - Toshi MARUYAMA
Toshi MARUYAMA wrote:

3.2-stable r14962 has completed.

Sorry, | have committed very minor 3.2-stable r14964.

Please release 3.2.0.

#20 - 2015-12-06 15:02 - Jean-Philippe Lang

Thanks.
